| The Gaudi Framework v27r1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Private Member Functions | Private Attributes | Static Private Attributes | List of all members
GaudiTool Class Reference

The useful base class for tools. More...

`#include <GaudiTools/GaudiTool.h>`

Inheritance diagram for GaudiTool:
[legend]
Collaboration diagram for GaudiTool:
[legend]

## Public Member Functions
StatusCode | initialize () override
| standard initialization method More...
StatusCode | finalize () override
| standard finalization method More...
INTupleSvc * | ntupleSvc () const
| Access the standard N-Tuple. More...
INTupleSvc * | evtColSvc () const
| Access the standard event collection service. More...
IDataProviderSvc * | detSvc () const
| accessor to detector service More...
IIncidentSvc * | incSvc () const
| accessor to Incident Service More...
IChronoStatSvc * | chronoSvc () const
| accessor to Chrono & Stat Service More...
IHistogramSvc * | histoSvc () const
| acessor to the histogram service More...
IAlgContextSvc * | contextSvc () const
| acessor to the Algorithm Context Service More...
DataObject * | put (IDataProviderSvc *svc, DataObject *object, const std::string &address, const bool useRootInTES=true) const
| Register a data object or container into Gaudi Event Transient Store. More...
DataObject * | put (DataObject *object, const std::string &address, const bool useRootInTES=true) const
| Register a data object or container into Gaudi Event Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | get (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Templated access to the data in Gaudi Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | getIfExists (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Templated access to the data in Gaudi Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | get (const std::string &location, const bool useRootInTES=true) const
| Templated access to the data from Gaudi Event Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | getIfExists (const std::string &location, const bool useRootInTES=true) const
| Templated access to the data in Gaudi Transient Store. More...
template<class TYPE >
TYPE * | getDet (IDataProviderSvc *svc, const std::string &location) const
| Templated access to the detector data from the Gaudi Detector Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | getDetIfExists (IDataProviderSvc *svc, const std::string &location) const
| Templated access to the detector data from the Gaudi Detector Transient Store. More...
template<class TYPE >
TYPE * | getDet (const std::string &location) const
| Templated access to the detector data from the Gaudi Detector Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | getDetIfExists (const std::string &location) const
| Templated access to the detector data from the Gaudi Detector Transient Store. More...
template<class TYPE >
bool | exist (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Check the existence of a data object or container in the Gaudi Transient Event Store. More...
template<class TYPE >
bool | exist (const std::string &location, const bool useRootInTES=true) const
| Check the existence of a data object or container in the Gaudi Transient Event Store. More...
template<class TYPE >
bool | existDet (IDataProviderSvc *svc, const std::string &location) const
| Check the existence of detector objects in the Gaudi Transient Detector Store. More...
template<class TYPE >
bool | existDet (const std::string &location) const
| Check the existence of detector objects in the Gaudi Transient Detector Store. More...
template<class TYPE , class TYPE2 >
Gaudi::Utils::GetData< TYPE >::return_type | getOrCreate (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Get the existing data object from Gaudi Event Transient store. More...
template<class TYPE , class TYPE2 >
Gaudi::Utils::GetData< TYPE >::return_type | getOrCreate (const std::string &location, const bool useRootInTES=true) const
| Get the existing data object from Gaudi Event Transient store. More...
StatusCode | Error (const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
| Print the error message and return with the given StatusCode. More...
StatusCode | Warning (const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
| Print the warning message and return with the given StatusCode. More...
StatusCode | Info (const std::string &msg, const StatusCode st=StatusCode::SUCCESS, const size_t mx=10) const
| Print the info message and return with the given StatusCode. More...
template<class T >
Property * | declareProperty (const std::string &name, DataObjectHandle< T > &hndl, const std::string &doc="none") const
Public Member Functions inherited from GaudiCommon< AlgTool >
Gaudi::Utils::GetData< TYPE >::return_type | get (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Templated access to the data in Gaudi Transient Store. More...
Gaudi::Utils::GetData< TYPE >::return_type | getIfExists (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Quicker version of the get function which bypasses the check on the retrieved data. More...
bool | exist (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Check the existence of a data object or container in the Gaudi Transient Event Store. More...
Gaudi::Utils::GetData< TYPE >::return_type | getOrCreate (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Get the existing data object from Gaudi Event Transient store. More...
DataObject * | put (IDataProviderSvc *svc, DataObject *object, const std::string &location, const bool useRootInTES=true) const
| Register a data object or container into Gaudi Event Transient Store. More...
TOOL * | tool (const std::string &type, const std::string &name, const IInterface *parent=0, bool create=true) const
| Useful method for the easy location of tools. More...
TOOL * | tool (const std::string &type, const IInterface *parent=0, bool create=true) const
| A useful method for the easy location of tools. More...
SmartIF< SERVICE > | svc (const std::string &name, const bool create=true) const
| A useful method for the easy location of services. More...
IUpdateManagerSvc * | updMgrSvc () const
| Short-cut to locate the Update Manager Service. More...
StatusCode | Error (const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
| Print the error message and return with the given StatusCode. More...
StatusCode | Warning (const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
| Print the warning message and return with the given StatusCode. More...
StatusCode | Info (const std::string &msg, const StatusCode st=StatusCode::SUCCESS, const size_t mx=10) const
| Print the info message and return with the given StatusCode. More...
StatusCode | Print (const std::string &msg, const StatusCode st=StatusCode::SUCCESS, const MSG::Level lev=MSG::INFO) const
| Print the message and return with the given StatusCode. More...
void | Assert (const bool ok, const std::string &message="", const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Assertion - throw exception if the given condition is not fulfilled. More...
void | Assert (const bool ok, const char *message, const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Assertion - throw exception if the given condition is not fulfilled. More...
void | Exception (const std::string &msg, const GaudiException &exc, const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Create and (re)-throw a given GaudiException. More...
void | Exception (const std::string &msg, const std::exception &exc, const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Create and (re)-throw a given exception. More...
void | Exception (const std::string &msg="no message", const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Create and throw an exception with the given message. More...
const Statistics & | counters () const
| accessor to all counters More...
StatEntity & | counter (const std::string &tag) const
| accessor to certain counter by name More...
bool | typePrint () const
| Insert the actual C++ type of the algorithm/tool in the messages ? More...
bool | propsPrint () const
| Print properties at initialization ? More...
bool | statPrint () const
| Print statistical counters at finalization ? More...
bool | errorsPrint () const
| Print error counters at finalization ? More...
long | printStat (const MSG::Level level=MSG::ALWAYS) const
| perform the actual printout of statistical counters More...
long | printErrors (const MSG::Level level=MSG::ALWAYS) const
| perform the actual printout of error counters More...
long | printProps (const MSG::Level level=MSG::ALWAYS) const
| perform the actual printout of properties More...
void | registerCondition (const std::string &condition, StatusCode(CallerClass::*mf)()=nullptr)
| register the current instance to the UpdateManagerSvc as a consumer for a condition. More...
void | registerCondition (const std::string &condition, CondType *&condPtrDest, StatusCode(CallerClass::*mf)()=NULL)
| register the current instance to the UpdateManagerSvc as a consumer for a condition. More...
void | registerCondition (char *condition, StatusCode(CallerClass::*mf)()=NULL)
| just to avoid conflicts with the version using a pointer to a template class. More...
void | registerCondition (TargetClass *condition, StatusCode(CallerClass::*mf)()=NULL)
| register the current instance to the UpdateManagerSvc as a consumer for a condition. More...
StatusCode | runUpdate ()
| asks the UpdateManagerSvc to perform an update of the instance (if needed) without waiting the next BeginEvent incident. More...
| GaudiCommon (const std::string &name, ISvcLocator *pSvcLocator)
| Algorithm constructor. More...
| GaudiCommon (const std::string &type, const std::string &name, const IInterface *parent)
| Tool constructor. More...
StatusCode | initialize () override
| standard initialization method More...
StatusCode | finalize () override
| standard finalization method More...
StatusCode | release (const IInterface *interface) const
| Manual forced (and 'safe') release of the active tool or service. More...
const Services & | services () const
| get the list of aquired services More...
const std::string & | context () const
| Returns the "context" string. Used to identify different processing states. More...
const std::string & | rootInTES () const
| Returns the "rootInTES" string. More...
const std::string | fullTESLocation (const std::string &location, const bool useRootInTES) const
| Returns the full correct event location given the rootInTes settings. More...
Public Member Functions inherited from AlgTool
StatusCode | queryInterface (const InterfaceID &riid, void **ppvUnknown) override
| Query for a given interface. More...
const std::string & | name () const override
| Retrieve full identifying name of the concrete tool object. More...
const std::string & | type () const override
| Retrieve type (concrete class) of the sub-algtool. More...
const IInterface * | parent () const override
| Retrieve parent of the sub-algtool. More...
StatusCode | configure () override
StatusCode | initialize () override
StatusCode | start () override
StatusCode | stop () override
StatusCode | finalize () override
StatusCode | terminate () override
StatusCode | reinitialize () override
StatusCode | restart () override
Gaudi::StateMachine::State | FSMState () const override
Gaudi::StateMachine::State | targetFSMState () const override
StatusCode | sysInitialize () override
| Initialize AlgTool. More...
StatusCode | sysStart () override
| Start AlgTool. More...
StatusCode | sysStop () override
| Stop AlgTool. More...
StatusCode | sysFinalize () override
| Finalize AlgTool. More...
StatusCode | sysReinitialize () override
| Initialize AlgTool. More...
StatusCode | sysRestart () override
| Start AlgTool. More...
StatusCode | setProperty (const Property &p) override
| Default implementations for IProperty interface. More...
StatusCode | setProperty (const std::string &s) override
StatusCode | setProperty (const std::string &n, const std::string &v) override
StatusCode | getProperty (Property *p) const override
const Property & | getProperty (const std::string &name) const override
StatusCode | getProperty (const std::string &n, std::string &v) const override
const std::vector< Property * > & | getProperties () const override
bool | hasProperty (const std::string &name) const override
PropertyMgr * | getPropertyMgr () const
template<class TYPE >
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
| AlgTool (const std::string &type, const std::string &name, const IInterface *parent)
| Standard Constructor. More...
SmartIF< ISvcLocator > & | serviceLocator () const override
| Retrieve pointer to service locator. More...
ISvcLocator * | svcLoc () const
| shortcut for the method service locator More...
IDataProviderSvc * | evtSvc () const
| accessor to event service service More...
IToolSvc * | toolSvc () const
| The standard ToolSvc service, Return a pointer to the service if present. More...
StatusCode | setProperties ()
| Method for setting declared properties to the values specified in the jobOptions via the job option service. More...
template<class T >
StatusCode | service (const std::string &name, T *&svc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &type, const std::string &name, T *&svc) const
| Access a service by name, type creating it if it doesn't already exist. More...
SmartIF< IService > | service (const std::string &name, const bool createIf=true, const bool quiet=false) const
| Return a pointer to the service identified by name (or "type/name") More...
template<typename T >
SmartIF< T > | service (const std::string &name, const bool createIf=true, const bool quiet=false) const
template<class T >
Property * | declareProperty (const std::string &name, T &property, const std::string &doc="none") const
| Declare the named property. More...
Property * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="") const
| Declare remote named properties. More...
template<class T >
Property * | declareProperty (const std::string &name, ToolHandle< T > &hndl, const std::string &doc="none") const
template<class T >
StatusCode | declareTool (ToolHandle< T > &handle, std::string toolTypeAndName="", bool createIf=true)
template<class T >
Property * | declareProperty (const std::string &name, ToolHandleArray< T > &hndlArr, const std::string &doc="none") const
virtual std::vector< Gaudi::DataHandle * > | inputHandles () const override
virtual std::vector< Gaudi::DataHandle * > | outputHandles () const override
virtual const DataObjIDColl & | extraInputDeps () const override
virtual const DataObjIDColl & | extraOutputDeps () const override
virtual void | acceptDHVisitor (IDataHandleVisitor *) const override
DataObjIDColl | inputDataObjs () const
DataObjIDColl | outputDataObjs () const
void | commitHandles () override
void | registerTool (IAlgTool *tool) const
void | deregisterTool (IAlgTool *tool) const
template<class T >
StatusCode | declarePublicTool (ToolHandle< T > &handle, std::string toolTypeAndName="", bool createIf=true)
| Declare used public tool. More...
template<class T >
StatusCode | declarePrivateTool (ToolHandle< T > &handle, std::string toolTypeAndName="", bool createIf=true)
| Declare used private tool. More...
const std::vector< IAlgTool * > & | tools () const
IAuditorSvc * | auditorSvc () const
| Access the auditor service. More...
IMonitorSvc * | monitorSvc () const
| Access the monitor service. More...
template<class T >
void | declareInfo (const std::string &name, const T &var, const std::string &desc) const
| Declare monitoring information. More...
void | declareInfo (const std::string &name, const std::string &format, const void *var, int size, const std::string &desc) const
| Declare monitoring information (special case) More...
| ~AlgTool () override
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...
MSG::Level | msgLevel () const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const __attribute__((deprecated))
| Backward compatibility function for getting the output level. More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...

## Static Public Member Functions
static bool | enableSummary (bool)
| enable/disable summary More...
static bool | summaryEnabled ()
| is summary enabled? More...

## Protected Member Functions
| GaudiTool (const std::string &type, const std::string &name, const IInterface *parent)
| Standard constructor. More...
| ~GaudiTool () override
| destructor, virtual and protected More...
Protected Member Functions inherited from GaudiCommon< AlgTool >
| ~GaudiCommon () override=default
| Destructor. More...
StatusCode | releaseTool (const IAlgTool *tool) const
| manual forced (and 'safe') release of the tool More...
StatusCode | releaseSvc (const IInterface *svc) const
| manual forced (and 'safe') release of the service More...
Protected Member Functions inherited from AlgTool
template<typename I >
void | declareInterface (I *i)
virtual void | declareInput (Gaudi::DataHandle *im) override
virtual void | declareOutput (Gaudi::DataHandle *im) override
std::vector< IAlgTool * > & | tools ()
Protected Member Functions inherited from CommonMessaging< implements< IAlgTool, IDataHandleHolder, IProperty, IStateful > >
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...

## Private Member Functions
| GaudiTool ()=delete
| no default/copy constructor, no assignment More...
| GaudiTool (const GaudiTool &)=delete
GaudiTool & | operator= (const GaudiTool &)=delete
bool | isPublic () const
| Determines if this tool is public or not (i.e. owned by the ToolSvc). More...
std::string | getCurrentAlgName () const
| Returns the current active algorithm name via the context service. More...

## Private Attributes
INTupleSvc * | m_ntupleSvc = nullptr
| pointer to the N-Tuple service More...
INTupleSvc * | m_evtColSvc = nullptr
| pointer to the event tag collection service More...
IDataProviderSvc * | m_detSvc = nullptr
| pointer to Detector Data Service More...
IChronoStatSvc * | m_chronoSvc = nullptr
| pointer to Chrono & Stat Service More...
IIncidentSvc * | m_incSvc = nullptr
| pointer to Incident Service More...
IHistogramSvc * | m_histoSvc = nullptr
| pointer for histogram service More...
IAlgContextSvc * | m_contextSvc = nullptr
| Algorithm Context Service. More...
std::string | m_contextSvcName = "AlgContextSvc"
| Algorithm Context Service. More...
bool | m_isPublic = false
| Flag to say if the tool is a public or private tool. More...
const std::string | m_local
| full tool name "type/name" More...

## Static Private Attributes
static bool | s_enableSummary = true
| enable printout of summary? More...

## Additional Inherited Members
Public Types inherited from AlgTool
typedef Gaudi::PluginService::Factory< IAlgTool *, const std::string &, const std::string &, const IInterface * > | Factory
Public Types inherited from CommonMessaging< implements< IAlgTool, IDataHandleHolder, IProperty, IStateful > >
using | base_class = CommonMessaging
Protected Types inherited from GaudiCommon< AlgTool >
using | base_class = AlgTool
typedef std::map< std::string, StatEntity > | Statistics
| the actual type of general counters More...
typedef std::map< std::string, unsigned int > | Counter
| the actual type error/warning counter More...
typedef std::vector< IAlgTool * > | AlgTools
| storage for active tools More...
typedef std::vector< SmartIF< IService > > | Services
| storage for active services More...
Protected Attributes inherited from GaudiCommon< AlgTool >
SmartIF< ICounterSummarySvc > | m_counterSummarySvc
| a pointer to the CounterSummarySvc More...
std::vector< std::string > | m_counterList
| list of counters to declare. Set by property CounterList. This can be a regular expression. More...
std::vector< std::string > | m_statEntityList
Protected Attributes inherited from AlgTool
std::unique_ptr< IDataHandleVisitor > | m_updateDataHandles
| Hook for for derived classes to provide a custom visitor for data handles. More...
SmartIF< PropertyMgr > | m_propertyMgr
| Property Manager. More...
Static Protected Attributes inherited from GaudiCommon< AlgTool >
static const bool | IgnoreRootInTES
| Simple definition to be used with the new useRootInTES argument get<TYPE> and put methods. More...
static const bool | UseRootInTES
| Simple definition to be used with the new useRootInTES argument get<TYPE> and put methods. More...

## Detailed Description

The useful base class for tools.

Small extension of ordinary the AlgTool base class.

This base class allows "easy"(=="1 line") access to tools and services. This access is safe in the sense that there is no need to worry about the reference counts for tools and services.

The base class allows "easy" (=="1 line") access to data in Gaudi Transient Stores. The functionality includes the checking of the presence of the data at the given location, checking the validity of the data, retrieval of valid data and "forced" retrieve of valid data (create if there is no data).

The base class allows to perform an easy error, warning and exception treatments, including the accumulated statistics of exceptions, errors and warnings.

The base class also includes utilities for general statistical counters.

It has been reported that usage of this base class results in significant reduction of existing code lines.

Attention
  See the class GaudiCommon, which implements some of the common functionality between GaudiTool and GaudiAlgorithm

Author
  Vanya BELYAEV Ivan..nosp@m.Bely.nosp@m.aev@i.nosp@m.tep..nosp@m.ru
  Chris Jones Chris.nosp@m.toph.nosp@m.er.Ro.nosp@m.b.Jo.nosp@m.nes@c.nosp@m.ern..nosp@m.ch

Date
  2003-07-07

Definition at line 98 of file GaudiTool.h.

## Constructor & Destructor Documentation

GaudiTool::GaudiTool | ( | const std::string & | type,
|  | const std::string & | name,
|  | const IInterface * | parent
| ) |  |
| protected

Standard constructor.

See also
  AlgTool

Parameters

  type | tool type (useless)
  name | tool name
  parent | pointer to parent object (service, algorithm or tool)

Definition at line 138 of file GaudiTool.cpp.

141 : GaudiCommon<AlgTool> ( this_type , this_name , parent )
142 , m_local ( this_type + "/" + this_name )
143 {
144 declareProperty
145 ( "ContextService" ,
146 m_contextSvcName ,
147 "The name of Algorithm Context Service" ) ;
148 // make instance counts
149 GaudiToolLocal::s_InstanceCounter.increment ( m_local ) ;
150 }
GaudiTool::m_contextSvcName
std::string m_contextSvcName
Algorithm Context Service.
Definition: GaudiTool.h:812
GaudiTool::declareProperty
Property * declareProperty(const std::string &name, DataObjectHandle< T > &hndl, const std::string &doc="none") const
Definition: GaudiTool.h:834
GaudiCommon< AlgTool >
GaudiTool::m_local
const std::string m_local
full tool name "type/name"
Definition: GaudiTool.h:822
AlgTool::parent
const IInterface * parent() const override
Retrieve parent of the sub-algtool.
Definition: AlgTool.cpp:79

GaudiTool::~GaudiTool | ( |  | ) |
| override protected

destructor, virtual and protected

Definition at line 154 of file GaudiTool.cpp.

155 {
156 GaudiToolLocal::s_InstanceCounter.decrement ( m_local ) ;
157 }
GaudiTool::m_local
const std::string m_local
full tool name "type/name"
Definition: GaudiTool.h:822

GaudiTool::GaudiTool | ( |  | ) |
| private delete

no default/copy constructor, no assignment

GaudiTool::GaudiTool | ( | const GaudiTool & |  | ) |
| private delete

## Member Function Documentation

IChronoStatSvc * GaudiTool::chronoSvc | ( |  | ) | const

accessor to Chrono & Stat Service

Returns
  pointer to the Chrono & Stat Service

Definition at line 267 of file GaudiTool.cpp.

268 {
269 if ( !m_chronoSvc )
270 {
271 m_chronoSvc =
272 svc<IChronoStatSvc> ( GaudiToolServices::s_ChronoStatSvc , true ) ;
273 }
274 return m_chronoSvc ;
275 }
GaudiTool::m_chronoSvc
IChronoStatSvc * m_chronoSvc
pointer to Chrono & Stat Service
Definition: GaudiTool.h:804
GaudiToolServices::s_ChronoStatSvc
const std::string s_ChronoStatSvc
the default name for Chrono & Stat Service
Definition: GaudiTool.cpp:47

IAlgContextSvc * GaudiTool::contextSvc | ( |  | ) | const

acessor to the Algorithm Context Service

Returns
  pointer to the Algorithm Context Service

Definition at line 290 of file GaudiTool.cpp.

291 {
292 if ( !m_contextSvc )
293 {
294 m_contextSvc = svc<IAlgContextSvc> ( m_contextSvcName , true ) ;
295 }
296 return m_contextSvc;
297 }
GaudiTool::m_contextSvcName
std::string m_contextSvcName
Algorithm Context Service.
Definition: GaudiTool.h:812
GaudiTool::m_contextSvc
IAlgContextSvc * m_contextSvc
Algorithm Context Service.
Definition: GaudiTool.h:810
template<class T >

Property* GaudiTool::declareProperty | ( | const std::string & | name,
|  | DataObjectHandle< T > & | hndl,
|  | const std::string & | doc = `"none"`
| ) |  | const
| inline

Definition at line 834 of file GaudiTool.h.

837 {
838
839 if ( hndl.mode() & Gaudi::DataHandle::Reader ) {
840 (const_cast<GaudiTool*>(this))->AlgTool::declareInput(&hndl);
841 }
842
843 if ( hndl.mode() & Gaudi::DataHandle::Writer ) {
844 (const_cast<GaudiTool*>(this))->AlgTool::declareOutput(&hndl);
845 }
846
847 if (hndl.owner() == 0) {
848 hndl.setOwner((const_cast<GaudiTool*>(this)));
849 }
850
851 return m_propertyMgr->declareProperty(name, hndl, doc);
852 }
Gaudi::DataHandle::setOwner
virtual void setOwner(IDataHandleHolder *o)
Definition: DataHandle.h:44
Gaudi::DataHandle::mode
virtual Mode mode() const
Definition: DataHandle.h:47
Gaudi::DataHandle::Reader
Definition: DataHandle.h:31
AlgTool::m_propertyMgr
SmartIF< PropertyMgr > m_propertyMgr
Property Manager.
Definition: AlgTool.h:490
PropertyMgr::declareProperty
Property * declareProperty(const std::string &name, TYPE &value, const std::string &doc="none")
Declare a property (templated)
Definition: PropertyMgr.h:186
Gaudi::DataHandle::Writer
Definition: DataHandle.h:32
GaudiTool
The useful base class for tools.
Definition: GaudiTool.h:98
Gaudi::DataHandle::owner
virtual IDataHandleHolder * owner() const
Definition: DataHandle.h:45

IDataProviderSvc * GaudiTool::detSvc | ( |  | ) | const

accessor to detector service

Returns
  pointer to detector service

Definition at line 221 of file GaudiTool.cpp.

222 {
223 if ( !m_detSvc )
224 {
225 m_detSvc =
226 svc<IDataProviderSvc>( GaudiToolServices::s_DetectorDataSvc , true ) ;
227 }
228 return m_detSvc ;
229 }
GaudiTool::m_detSvc
IDataProviderSvc * m_detSvc
pointer to Detector Data Service
Definition: GaudiTool.h:802
GaudiToolServices::s_DetectorDataSvc
const std::string s_DetectorDataSvc
the default name for Detector Data Service
Definition: GaudiTool.cpp:45

bool GaudiTool::enableSummary | ( | bool | value | ) |
| static

enable/disable summary

Definition at line 125 of file GaudiTool.cpp.

126 {
127 s_enableSummary = value ;
128 return summaryEnabled () ;
129 }
dump_component_properties.value
list value
Definition: dump_component_properties.py:12
GaudiTool::s_enableSummary
static bool s_enableSummary
enable printout of summary?
Definition: GaudiTool.h:827
GaudiTool::summaryEnabled
static bool summaryEnabled()
is summary enabled?
Definition: GaudiTool.cpp:133

StatusCode GaudiTool::Error | ( | const std::string & | msg,
|  | const StatusCode | st = `StatusCode::FAILURE`,
|  | const size_t | mx = `10`
| ) |  | const
| inline

Print the error message and return with the given StatusCode.

Also performs statistical analysis of the error messages and suppression after the defined number of error instances.

if( a < 0 ) { return Error("a is negative!") ;}
if( b < 0 ) { return Error("b is illegal!" , StatusCode(25) );
if( c < 0 )
{ return Error("c is negative" , StatusCode(35) , 50 );

See also
  MsgStream
  IMessageSvc
  StatusCode

Parameters

  msg | Error message
  st | StatusCode to return
  mx | Maximum number of printouts for this message

Returns
  StatusCode

Definition at line 689 of file GaudiTool.h.

692 {
693 return GaudiCommon<AlgTool>::Error( m_isPublic ?
694 msg + getCurrentAlgName() : msg,
695 st, mx );
696 }
GaudiTool::m_isPublic
bool m_isPublic
Flag to say if the tool is a public or private tool.
Definition: GaudiTool.h:817
GaudiCommon::Error
StatusCode Error(const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
Print the error message and return with the given StatusCode.
Definition: GaudiCommon.icpp:459
GaudiTool::getCurrentAlgName
std::string getCurrentAlgName() const
Returns the current active algorithm name via the context service.
Definition: GaudiTool.h:788

INTupleSvc * GaudiTool::evtColSvc | ( |  | ) | const

Access the standard event collection service.

Returns
  pointer to the event collection service

Definition at line 244 of file GaudiTool.cpp.

245 {
246 if ( !m_evtColSvc )
247 {
248 m_evtColSvc = svc< INTupleSvc > ( "EvtTupleSvc" , true ) ;
249 }
250 return m_evtColSvc ;
251 }
GaudiTool::m_evtColSvc
INTupleSvc * m_evtColSvc
pointer to the event tag collection service
Definition: GaudiTool.h:800
template<class TYPE >

bool GaudiTool::exist | ( | IDataProviderSvc * | svc,
|  | const std::string & | location,
|  | const bool | useRootInTES = `true`
| ) |  | const
| inline

Check the existence of a data object or container in the Gaudi Transient Event Store.

bool a1 = exist<DataObject>( evtSvc(), "/Event/MyObject" ) ;
bool a2 = exist<MyHits> ( evtSvc(), "/Event/MyHits" ) ;

Attention
  The method respects the setting of the job option RootInTES by prepending the value of this to the data location that is passed. The default setting for RootInTES is "" so has no effect. This behavior can be suppressed by passing the argument useRootInTES = false

Parameters

  svc | Pointer to data service (data provider)
  location | Address in Gaudi Transient Event Store
  useRootInTES | Flag to turn on(TRUE) off(FALSE) the use of the RootInTES location property

Returns
  Boolean indicating status of the request

Return values

  true | Data object or container exists and implements a proper interface
  true | Failed to locate the data object or container

Definition at line 515 of file GaudiTool.h.

518 {
519 return GaudiCommon<AlgTool>::exist<TYPE> ( svc , location , useRootInTES ) ;
520 }
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:73
GaudiCommon< AlgTool >::svc
SmartIF< SERVICE > svc(const std::string &name, const bool create=true) const
A useful method for the easy location of services.
template<class TYPE >

bool GaudiTool::exist | ( | const std::string & | location,
|  | const bool | useRootInTES = `true`
| ) |  | const
| inline

Check the existence of a data object or container in the Gaudi Transient Event Store.

bool a1 = exist<DataObject>( "/Event/MyObject" ) ;
bool a2 = exist<MyHits> ( "/Event/MyHits" ) ;

Attention
  The method respects the setting of the job option RootInTES by prepending the value of this to the data location that is passed. The default setting for RootInTES is "" so has no effect. This behavior can be suppressed by passing the argument useRootInTES = false

Parameters

  location | Address in Gaudi Transient Event Store

Returns
  Boolean indicating status of the request

Return values

  true | Data object or container exists and implements a proper interface
  true | Failed to locate the data object or container

Definition at line 545 of file GaudiTool.h.

547 {
548 return GaudiCommon<AlgTool>::exist<TYPE> ( evtSvc() , location , useRootInTES ) ;
549 }
AlgTool::evtSvc
IDataProviderSvc * evtSvc() const
accessor to event service service
Definition: AlgTool.cpp:95
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:73
template<class TYPE >

bool GaudiTool::existDet | ( | IDataProviderSvc * | svc,
|  | const std::string & | location
| ) |  | const
| inline

Check the existence of detector objects in the Gaudi Transient Detector Store.

bool a1 = existDet<DataObject> ( detSvc(), "/dd/Structure/MyObject" ) ;
bool a2 = existDet<Material> ( detSvc(), "/dd/Structure/Material/Air" ) ;

Parameters

  svc | Pointer to data service (data provider)
  location | Address in Gaudi Transient Detector Store

Returns
  Boolean indicating status of the request

Return values

  true | Detector object exists and implements a proper interface
  false | Failed to locate the data object

Definition at line 568 of file GaudiTool.h.

570 {
571 return GaudiCommon<AlgTool>::exist<TYPE> ( svc , location , false ) ;
572 }
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:73
GaudiCommon< AlgTool >::svc
SmartIF< SERVICE > svc(const std::string &name, const bool create=true) const
A useful method for the easy location of services.
template<class TYPE >

bool GaudiTool::existDet | ( | const std::string & | location | ) | const
| inline

Check the existence of detector objects in the Gaudi Transient Detector Store.

bool a1 = existDet<DataObject> ( "/dd/Structure/MyObject" ) ;
bool a2 = existDet<Material> ( "/dd/Structure/Material/Air" ) ;

Parameters

  location | Address in Gaudi Transient Detector Store

Returns
  Boolean indicating status of the request

Return values

  true | Detector object exists and implements a proper interface
  false | Failed to locate the data object

Definition at line 590 of file GaudiTool.h.

591 {
592 return GaudiCommon<AlgTool>::exist<TYPE> ( detSvc() , location , false ) ;
593 }
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:73
GaudiTool::detSvc
IDataProviderSvc * detSvc() const
accessor to detector service
Definition: GaudiTool.cpp:221

StatusCode GaudiTool::finalize | ( |  | ) |
| override

standard finalization method

See also
  AlgTool
  IAlgTool

Returns
  status code

Definition at line 179 of file GaudiTool.cpp.

180 {
181 if ( msgLevel(MSG::DEBUG) )
182 debug() << " ==> Finalize the base class GaudiTool " << endmsg;
183
184 // clear "explicit services"
185 m_detSvc = nullptr ;
186 m_chronoSvc = nullptr ;
187 m_incSvc = nullptr ;
188 m_histoSvc = nullptr ;
189
190 // finalize the base class
191 const StatusCode sc = GaudiCommon<AlgTool>::finalize() ;
192 if ( sc.isFailure() ) { return sc; }
193
194 // Decrement the counter
195 GaudiToolLocal::s_FinalizeCounter.decrement( m_local ) ;
196
197 // return
198 return sc;
199 }
GaudiTool::m_chronoSvc
IChronoStatSvc * m_chronoSvc
pointer to Chrono & Stat Service
Definition: GaudiTool.h:804
MSG::DEBUG
Definition: IMessageSvc.h:18
GaudiTool::m_detSvc
IDataProviderSvc * m_detSvc
pointer to Detector Data Service
Definition: GaudiTool.h:802
GaudiCommon::finalize
StatusCode finalize() override
standard finalization method
Definition: GaudiCommon.icpp:280
merge_files.sc
int sc
Definition: merge_files.py:167
StatusCode::isFailure
bool isFailure() const
Test for a status code of FAILURE.
Definition: StatusCode.h:86
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:26
GaudiTool::m_histoSvc
IHistogramSvc * m_histoSvc
pointer for histogram service
Definition: GaudiTool.h:808
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:127
GaudiTool::m_incSvc
IIncidentSvc * m_incSvc
pointer to Incident Service
Definition: GaudiTool.h:806
GaudiTool::m_local
const std::string m_local
full tool name "type/name"
Definition: GaudiTool.h:822
CommonMessagingBase::msgLevel
MSG::Level msgLevel() const
get the output level from the embedded MsgStream
Definition: CommonMessaging.h:136
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244
template<class TYPE >

Gaudi::Utils::GetData<TYPE>::return_type GaudiTool::get | ( | IDataProviderSvc * | svc,
|  | const std::string & | location,
|  | const bool | useRootInTES = `true`
| ) |  | const
| inline

Templated access to the data in Gaudi Transient Store.

Quick and safe access to the data in Gaudi transient store. The method located the data at given address and perform the debug printout about located data

MCHits* hits = get<MCHits>( evtSvc() , "/Event/MC/Hits" );

Attention
  The method respects the setting of the job option RootInTES by prepending the value of this to the data location that is passed. The default setting for RootInTES is "" so has no effect. This behavior can be suppressed by passing the argument useRootInTES = false

See also
  IDataProviderSvc
  SmartDataPtr

Exceptions

  GaudiException | for Invalid Data Provider Service
  GaudiException | for invalid/unavailable data

Parameters

  svc | Pointer to data service (data provider)
  location | data location/address in Gaudi Transient Store
  useRootInTES | Flag to turn on(TRUE) off(FALSE) the use of the RootInTES location property

Returns
  pointer to the data object

Definition at line 261 of file GaudiTool.h.

264 {
265 return GaudiCommon<AlgTool>::get<TYPE> ( svc , location , useRootInTES ) ;
266 }
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:73
GaudiCommon< AlgTool >::svc
SmartIF< SERVICE > svc(const std::string &name, const bool create=true) const
A useful method for the easy location of services.
template<class TYPE >

Gaudi::Utils::GetData<TYPE>::return_type GaudiTool::get | ( | const std::string & | location,
|  | const bool | useRootInTES = `true`
| ) |  | const
| inline

Templated access to the data from Gaudi Event Transient Store.

Quick and safe access to the data in Gaudi transient store.

The method located the data at the given address and perform the debug printout about located data.

MCParticles* mcps = get<MCParticles>( MCParticleLocation::Default );

Attention
  The method respects the setting of the job option RootInTES by prepending the value of this to the data location that is passed. The default setting for RootInTES is "" so has no effect. This behavior can be suppressed by passing the argument useRootInTES = false

Parameters

  location | Data location/address in Gaudi Transient Store
  useRootInTES | Flag to turn on(TRUE) off(FALSE) the use of the RootInTES location property

Returns
  Pointer to the data object

Definition at line 337 of file GaudiTool.h.

339 {
340 return GaudiCommon<AlgTool>::get<TYPE> ( evtSvc() , location , useRootInTES ) ;
341 }
AlgTool::evtSvc
IDataProviderSvc * evtSvc() const
accessor to event service service
Definition: AlgTool.cpp:95
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:73

std::string GaudiTool::getCurrentAlgName | ( |  | ) | const
| inline private

Returns the current active algorithm name via the context service.

Definition at line 788 of file GaudiTool.h.

789 {
790 const IAlgContextSvc * asvc = this->contextSvc();
791 const IAlgorithm * current = ( asvc ? asvc->currentAlg() : NULL );
792 return ( current ? " [" + current->name() + "]" : "" );
793 }
GaudiTool::contextSvc
IAlgContextSvc * contextSvc() const
acessor to the Algorithm Context Service
Definition: GaudiTool.cpp:290
IAlgorithm
The IAlgorithm is the interface implemented by the Algorithm base class.
Definition: IAlgorithm.h:25
IAlgContextSvc
An abstract interface for Algorithm Context Service.
Definition: IAlgContextSvc.h:23
IAlgContextSvc::currentAlg
virtual IAlgorithm * currentAlg() const =0
accessor to current algorithm:
template<class TYPE >

TYPE* GaudiTool::getDet | ( | IDataProviderSvc * | svc,
|  | const std::string & | location
| ) |  | const
| inline

Templated access to the detector data from the Gaudi Detector Transient Store.

Quick and safe access to the detector data in Gaudi transient store.

The method located the detector at the given address and perform the debug printout about located detector.

MyDet* mdet = getDet<MyDet>( detSvc() , "/dd/Structure/LHCb/MyDet" );

Parameters

  svc | Pointer to data service (data provider)
  location | Detector location/address in Gaudi Transient Store

Returns
  Pointer to the detector object

Definition at line 402 of file GaudiTool.h.

404 {
405 return GaudiCommon<AlgTool>::get<TYPE> ( svc , location , false ) ;
406 }
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:73
GaudiCommon< AlgTool >::svc
SmartIF< SERVICE > svc(const std::string &name, const bool create=true) const
A useful method for the easy location of services.
template<class TYPE >

TYPE* GaudiTool::getDet | ( | const std::string & | location | ) | const
| inline

Templated access to the detector data from the Gaudi Detector Transient Store.

Quick and safe access to the detector data in Gaudi transient store.

The method located the detector at the given address and perform the debug printout about located detector.

MyDet* mdet = getDet<MyDet>( "/dd/Structure/LHCb/MyDet" );

Parameters

  location | Detector location/address in Gaudi Transient Store

Returns
  Pointer to the detector object

Definition at line 456 of file GaudiTool.h.

457 {
458 return GaudiCommon<AlgTool>::get<TYPE> ( detSvc() , location , false ) ;
459 }
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:73
GaudiTool::detSvc
IDataProviderSvc * detSvc() const
accessor to detector service
Definition: GaudiTool.cpp:221
template<class TYPE >

Gaudi::Utils::GetData<TYPE>::return_type GaudiTool::getDetIfExists | ( | IDataProviderSvc * | svc,
|  | const std::string & | location
| ) |  | const
| inline

Templated access to the detector data from the Gaudi Detector Transient Store.

Quick and safe access to the detector data in Gaudi transient store.

The method located the detector at the given address and perform the debug printout about located detector.

Skips the check on the data as performed by 'get'. No exception is thrown if the data is missing.

MyDet* mdet = getDetIfExists<MyDet>( detSvc() , "/dd/Structure/LHCb/MyDet" );

Parameters

  svc | Pointer to data service (data provider)
  location | Detector location/address in Gaudi Transient Store

Returns
  Pointer to the detector object

Return values

  NULL | If the detector object does not exist.

Definition at line 432 of file GaudiTool.h.

434 {
435 return GaudiCommon<AlgTool>::getIfExists<TYPE> ( svc , location , false ) ;
436 }
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:73
GaudiCommon< AlgTool >::svc
SmartIF< SERVICE > svc(const std::string &name, const bool create=true) const
A useful method for the easy location of services.
template<class TYPE >

Gaudi::Utils::GetData<TYPE>::return_type GaudiTool::getDetIfExists | ( | const std::string & | location | ) | const
| inline

Templated access to the detector data from the Gaudi Detector Transient Store.

Quick and safe access to the detector data in Gaudi transient store.

The method located the detector at the given address and perform the debug printout about located detector.

Skips the check on the data as performed by 'get'. No exception is thrown if the data is missing.

MyDet* mdet = getDetIfExists<MyDet>( "/dd/Structure/LHCb/MyDet" );

Parameters

  location | Detector location/address in Gaudi Transient Store

Returns
  Pointer to the detector object

Return values

  NULL | If the detector object does not exist.

Definition at line 484 of file GaudiTool.h.

485 {
486 return GaudiCommon<AlgTool>::getIfExists<TYPE> ( detSvc() , location , false ) ;
487 }
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:73
GaudiTool::detSvc
IDataProviderSvc * detSvc() const
accessor to detector service
Definition: GaudiTool.cpp:221
template<class TYPE >

Gaudi::Utils::GetData<TYPE>::return_type GaudiTool::getIfExists | ( | IDataProviderSvc * | svc,
|  | const std::string & | location,
|  | const bool | useRootInTES = `true`
| ) |  | const
| inline

Templated access to the data in Gaudi Transient Store.

Quick and safe access to the data in Gaudi transient store. The method located the data at given address and perform the debug printout about located data.

Skips the check on the data as performed by 'get'. No exception is thrown if the data is missing.

MCHits* hits = getIfExists<MCHits>( evtSvc() , "/Event/MC/Hits" );

Attention
  The method respects the setting of the job option RootInTES by prepending the value of this to the data location that is passed. The default setting for RootInTES is "" so has no effect. This behavior can be suppressed by passing the argument useRootInTES = false

See also
  IDataProviderSvc
  SmartDataPtr

Parameters

  svc | Pointer to data service (data provider)
  location | data location/address in Gaudi Transient Store
  useRootInTES | Flag to turn on(TRUE) off(FALSE) the use of the RootInTES location property

Returns
  pointer to the data object.

Return values

  NULL | If data does not exist.

Definition at line 303 of file GaudiTool.h.

306 {
307 return GaudiCommon<AlgTool>::getIfExists<TYPE> ( svc , location , useRootInTES ) ;
308 }
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:73
GaudiCommon< AlgTool >::svc
SmartIF< SERVICE > svc(const std::string &name, const bool create=true) const
A useful method for the easy location of services.
template<class TYPE >

Gaudi::Utils::GetData<TYPE>::return_type GaudiTool::getIfExists | ( | const std::string & | location,
|  | const bool | useRootInTES = `true`
| ) |  | const
| inline

Templated access to the data in Gaudi Transient Store.

Quick and safe access to the data in Gaudi transient store. The method located the data at given address and perform the debug printout about located data.

Skips the check on the data as performed by 'get'. No exception is thrown if the data is missing.

MCHits* hits = getIfExists<MCHits>( "/Event/MC/Hits" );

Attention
  The method respects the setting of the job option RootInTES by prepending the value of this to the data location that is passed. The default setting for RootInTES is "" so has no effect. This behavior can be suppressed by passing the argument useRootInTES = false

See also
  IDataProviderSvc
  SmartDataPtr

Parameters

  location | data location/address in Gaudi Transient Store
  useRootInTES | Flag to turn on(TRUE) off(FALSE) the use of the RootInTES location property

Returns
  pointer to the data object.

Return values

  NULL | If data does not exist.

Definition at line 377 of file GaudiTool.h.

379 {
380 return GaudiCommon<AlgTool>::getIfExists<TYPE> ( evtSvc() , location , useRootInTES ) ;
381 }
AlgTool::evtSvc
IDataProviderSvc * evtSvc() const
accessor to event service service
Definition: AlgTool.cpp:95
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:73
template<class TYPE , class TYPE2 >

Gaudi::Utils::GetData<TYPE>::return_type GaudiTool::getOrCreate | ( | IDataProviderSvc * | svc,
|  | const std::string & | location,
|  | const bool | useRootInTES = `true`
| ) |  | const
| inline

Get the existing data object from Gaudi Event Transient store.

Alternatively, create new object and register it in TES and return if object does not exist.

MyHits* hits = getOrCreate<MyHits,MyHits>( evtSvc() , "/Event/MyHits" ) ;

Attention
  The method respects the setting of the job option RootInTES by prepending the value of this to the data location that is passed. The default setting for RootInTES is "" so has no effect. This behavior can be suppressed by passing the argument useRootInTES = false

Exceptions

  GaudiException | for Invalid Data Provider Service
  GaudiException | for invalid/unavailable data

Parameters

  svc | Pointer to data service (data provider)
  location | Location in Gaudi Transient Event Store
  useRootInTES | Flag to turn on(TRUE) off(FALSE) the use of the RootInTES location property

Returns
  A valid pointer to the object

Definition at line 623 of file GaudiTool.h.

626 {
627 return GaudiCommon<AlgTool>::getOrCreate<TYPE,TYPE2> ( svc , location , useRootInTES ) ;
628 }
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:73
GaudiCommon< AlgTool >::svc
SmartIF< SERVICE > svc(const std::string &name, const bool create=true) const
A useful method for the easy location of services.
template<class TYPE , class TYPE2 >

Gaudi::Utils::GetData<TYPE>::return_type GaudiTool::getOrCreate | ( | const std::string & | location,
|  | const bool | useRootInTES = `true`
| ) |  | const
| inline

Get the existing data object from Gaudi Event Transient store.

Alternatively, create new object and register it in TES and return if object does not exist.

MyHits* hits = getOrCreate<MyHits,MyHits>( "/Event/MyHits" ) ;

Attention
  The method respects the setting of the job option RootInTES by prepending the value of this to the data location that is passed. The default setting for RootInTES is "" so has no effect. This behavior can be suppressed by passing the argument useRootInTES = false

Exceptions

  GaudiException | for Invalid Data Provider Service
  GaudiException | for invalid/unavailable data

Parameters

  location | Location in Gaudi Transient Event Store
  useRootInTES | Flag to turn on(TRUE) off(FALSE) the use of the RootInTES location property

Returns
  A valid pointer to the object

Definition at line 657 of file GaudiTool.h.

659 {
660 return GaudiCommon<AlgTool>::getOrCreate<TYPE,TYPE2> ( evtSvc() , location , useRootInTES ) ;
661 }
AlgTool::evtSvc
IDataProviderSvc * evtSvc() const
accessor to event service service
Definition: AlgTool.cpp:95
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:73

IHistogramSvc * GaudiTool::histoSvc | ( |  | ) | const

acessor to the histogram service

Returns
  pointer to the histogram service

Definition at line 279 of file GaudiTool.cpp.

280 {
281 if ( !m_histoSvc )
282 {
283 m_histoSvc = svc<IHistogramSvc> ( GaudiToolServices::s_HistoSvc, true ) ;
284 }
285 return m_histoSvc;
286 }
GaudiToolServices::s_HistoSvc
const std::string s_HistoSvc
the default name for Histogram Service
Definition: GaudiTool.cpp:51
GaudiTool::m_histoSvc
IHistogramSvc * m_histoSvc
pointer for histogram service
Definition: GaudiTool.h:808

IIncidentSvc * GaudiTool::incSvc | ( |  | ) | const

accessor to Incident Service

Returns
  pointer to the Incident Service

Definition at line 255 of file GaudiTool.cpp.

256 {
257 if ( !m_incSvc )
258 {
259 m_incSvc =
260 svc<IIncidentSvc> ( GaudiToolServices::s_IncidentSvc , true ) ;
261 }
262 return m_incSvc ;
263 }
GaudiToolServices::s_IncidentSvc
const std::string s_IncidentSvc
the default name for Incident Service
Definition: GaudiTool.cpp:49
GaudiTool::m_incSvc
IIncidentSvc * m_incSvc
pointer to Incident Service
Definition: GaudiTool.h:806

StatusCode GaudiTool::Info | ( | const std::string & | msg,
|  | const StatusCode | st = `StatusCode::SUCCESS`,
|  | const size_t | mx = `10`
| ) |  | const
| inline

Print the info message and return with the given StatusCode.

Also performs statistical analysis of the info messages and suppression after the defined number of instances.

See also
  MsgStream
  IMessageSvc
  StatusCode
  GaudiCommon::Warning

Parameters

  msg | Info message
  st | StatusCode to return
  mx | Maximum number of printouts for this message

Returns
  The given StatusCode

Definition at line 745 of file GaudiTool.h.

748 {
749 return GaudiCommon<AlgTool>::Info( m_isPublic ?
750 msg + getCurrentAlgName() : msg,
751 st, mx );
752 }
GaudiTool::m_isPublic
bool m_isPublic
Flag to say if the tool is a public or private tool.
Definition: GaudiTool.h:817
GaudiTool::getCurrentAlgName
std::string getCurrentAlgName() const
Returns the current active algorithm name via the context service.
Definition: GaudiTool.h:788
GaudiCommon::Info
StatusCode Info(const std::string &msg, const StatusCode st=StatusCode::SUCCESS, const size_t mx=10) const
Print the info message and return with the given StatusCode.
Definition: GaudiCommon.icpp:501

StatusCode GaudiTool::initialize | ( |  | ) |
| override

standard initialization method

See also
  AlgTool
  IAlgTool

Returns
  status code

Definition at line 161 of file GaudiTool.cpp.

162 {
163 // initialize the base class
164 const StatusCode sc = GaudiCommon<AlgTool>::initialize() ;
165 if ( sc.isFailure() ) { return sc; }
166
167 // increment the counter
168 GaudiToolLocal::s_FinalizeCounter.increment( m_local ) ;
169
170 // are we a public tool ?
171 m_isPublic = isPublic();
172
173 // return
174 return sc;
175 }
GaudiTool::m_isPublic
bool m_isPublic
Flag to say if the tool is a public or private tool.
Definition: GaudiTool.h:817
merge_files.sc
int sc
Definition: merge_files.py:167
StatusCode::isFailure
bool isFailure() const
Test for a status code of FAILURE.
Definition: StatusCode.h:86
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:26
GaudiTool::isPublic
bool isPublic() const
Determines if this tool is public or not (i.e. owned by the ToolSvc).
Definition: GaudiTool.cpp:203
GaudiCommon::initialize
StatusCode initialize() override
standard initialization method
Definition: GaudiCommon.icpp:186
GaudiTool::m_local
const std::string m_local
full tool name "type/name"
Definition: GaudiTool.h:822

bool GaudiTool::isPublic | ( |  | ) | const
| private

Determines if this tool is public or not (i.e. owned by the ToolSvc).

Definition at line 203 of file GaudiTool.cpp.

204 {
205 const IAlgTool * tool = this;
206 // Recurse down the ownership tree, to see with we ever end up at the ToolSvc
207 bool ownedByToolSvc = false;
208 unsigned int sanityCheck(0);
209 while ( tool && ++sanityCheck < 99999 )
210 {
211 ownedByToolSvc = ( nullptr != dynamic_cast<const IToolSvc*>(tool->parent()) );
212 if ( ownedByToolSvc ) { break; }
213 // if parent is also a tool, try again
214 tool = dynamic_cast<const IAlgTool*>(tool->parent());
215 }
216 return ownedByToolSvc;
217 }
IToolSvc
The interface implemented by the IToolSvc base class.
Definition: IToolSvc.h:18
IAlgTool::parent
virtual const IInterface * parent() const =0
The parent of the concrete AlgTool.
IAlgTool
The interface implemented by the AlgTool base class.
Definition: IAlgTool.h:23
GaudiCommon< AlgTool >::tool
TOOL * tool(const std::string &type, const std::string &name, const IInterface *parent=0, bool create=true) const
Useful method for the easy location of tools.

INTupleSvc * GaudiTool::ntupleSvc | ( |  | ) | const

Access the standard N-Tuple.

Returns
  pointer to N-Tuple service .

Definition at line 233 of file GaudiTool.cpp.

234 {
235 if ( !m_ntupleSvc )
236 {
237 m_ntupleSvc = svc<INTupleSvc>( "NTupleSvc" , true ) ;
238 }
239 return m_ntupleSvc ;
240 }
GaudiTool::m_ntupleSvc
INTupleSvc * m_ntupleSvc
pointer to the N-Tuple service
Definition: GaudiTool.h:798

GaudiTool& GaudiTool::operator= | ( | const GaudiTool & |  | ) |
| private delete

DataObject* GaudiTool::put | ( | IDataProviderSvc * | svc,
|  | DataObject * | object,
|  | const std::string & | address,
|  | const bool | useRootInTES = `true`
| ) |  | const
| inline

Register a data object or container into Gaudi Event Transient Store.

MCHits * hits = new MCHits();
put( evtSvc(), hits, "/Event/MC/Hits" );

Attention
  The method respects the setting of the job option RootInTES by prepending the value of this to the data location that is passed. The default setting for RootInTES is "" so has no effect. This behavior can be suppressed by passing the argument useRootInTES = false

See also
  IDataProviderSvc

Parameters

  svc | Pointer to data provider service
  object | Data object or container to be registered
  address | Address in Gaudi Event Transient Store ("/Event" could be omitted )
  useRootInTES | Flag to turn on(TRUE) off(FALSE) the use of the RootInTES location property

Exceptions

  GaudiException | for invalid event data service
  GaudiException | for invalid object
  GaudiException | for error result from event data service

Returns
  StatusCode

Return values

  StatusCode::SUCCESS | Data was successfully placed in the TES.
  StatusCode::FAILURE | Failed to store data in the TES.

Definition at line 185 of file GaudiTool.h.

189 {
190 return GaudiCommon<AlgTool>::put ( svc , object , address , useRootInTES ) ;
191 }
GaudiCommon::put
DataObject * put(IDataProviderSvc *svc, DataObject *object, const std::string &location, const bool useRootInTES=true) const
Register a data object or container into Gaudi Event Transient Store.
Definition: GaudiCommon.icpp:686

DataObject* GaudiTool::put | ( | DataObject * | object,
|  | const std::string & | address,
|  | const bool | useRootInTES = `true`
| ) |  | const
| inline

Register a data object or container into Gaudi Event Transient Store.

See also
  IDataProviderSvc

MCHits * hits = put( new MCHits(), "/Event/MC/Hits" );

Attention
  The method respects the setting of the job option RootInTES by prepending the value of this to the data location that is passed. The default setting for RootInTES is "" so has no effect. This behavior can be suppressed by passing the argument useRootInTES = false

Parameters

  object | Data object or container to be registered
  address | Address in Gaudi Event Transient Store ("/Event" could be omitted )
  useRootInTES | Flag to turn on(TRUE) off(FALSE) the use of the RootInTES location property

Exceptions

  GaudiException | for invalid event data service
  GaudiException | for invalid object
  GaudiException | for error result from event data service

Returns
  StatusCode

Return values

  StatusCode::SUCCESS | Data was successfully placed in the TES.
  StatusCode::FAILURE | Failed to store data in the TES.

Definition at line 221 of file GaudiTool.h.

224 {
225 return GaudiCommon<AlgTool>::put ( evtSvc() , object , address , useRootInTES ) ;
226 }
GaudiCommon::put
DataObject * put(IDataProviderSvc *svc, DataObject *object, const std::string &location, const bool useRootInTES=true) const
Register a data object or container into Gaudi Event Transient Store.
Definition: GaudiCommon.icpp:686
AlgTool::evtSvc
IDataProviderSvc * evtSvc() const
accessor to event service service
Definition: AlgTool.cpp:95

bool GaudiTool::summaryEnabled | ( |  | ) |
| static

is summary enabled?

Definition at line 133 of file GaudiTool.cpp.

134 { return s_enableSummary ; }
GaudiTool::s_enableSummary
static bool s_enableSummary
enable printout of summary?
Definition: GaudiTool.h:827

StatusCode GaudiTool::Warning | ( | const std::string & | msg,
|  | const StatusCode | st = `StatusCode::FAILURE`,
|  | const size_t | mx = `10`
| ) |  | const
| inline

Print the warning message and return with the given StatusCode.

Also performs statistical analysis of the warning messages and suppression after the defined number of error instances.

if( a < 0 ) { return Warning("a is negative!") ;}
if( b < 0 ) { return Warning("b is illegal!" , StatusCode(25) );
if( c < 0 )
{ return Warning("c is negative" , StatusCode(35) , 50 );

See also
  MsgStream
  IMessageSvc
  StatusCode

Parameters

  msg | Warning message
  st | StatusCode to return
  mx | Maximum number of printouts for this message

Returns
  The given StatusCode

Definition at line 721 of file GaudiTool.h.

724 {
725 return GaudiCommon<AlgTool>::Warning( m_isPublic ?
726 msg + getCurrentAlgName() : msg,
727 st, mx );
728 }
GaudiTool::m_isPublic
bool m_isPublic
Flag to say if the tool is a public or private tool.
Definition: GaudiTool.h:817
GaudiTool::getCurrentAlgName
std::string getCurrentAlgName() const
Returns the current active algorithm name via the context service.
Definition: GaudiTool.h:788
GaudiCommon::Warning
StatusCode Warning(const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
Print the warning message and return with the given StatusCode.
Definition: GaudiCommon.icpp:480

## Member Data Documentation

IChronoStatSvc* GaudiTool::m_chronoSvc = nullptr
| mutable private

pointer to Chrono & Stat Service

Definition at line 804 of file GaudiTool.h.

IAlgContextSvc* GaudiTool::m_contextSvc = nullptr
| mutable private

Algorithm Context Service.

Definition at line 810 of file GaudiTool.h.

std::string GaudiTool::m_contextSvcName = "AlgContextSvc"
| private

Algorithm Context Service.

Definition at line 812 of file GaudiTool.h.

IDataProviderSvc* GaudiTool::m_detSvc = nullptr
| mutable private

pointer to Detector Data Service

Definition at line 802 of file GaudiTool.h.

INTupleSvc* GaudiTool::m_evtColSvc = nullptr
| mutable private

pointer to the event tag collection service

Definition at line 800 of file GaudiTool.h.

IHistogramSvc* GaudiTool::m_histoSvc = nullptr
| mutable private

pointer for histogram service

Definition at line 808 of file GaudiTool.h.

IIncidentSvc* GaudiTool::m_incSvc = nullptr
| mutable private

pointer to Incident Service

Definition at line 806 of file GaudiTool.h.

bool GaudiTool::m_isPublic = false
| private

Flag to say if the tool is a public or private tool.

Definition at line 817 of file GaudiTool.h.

const std::string GaudiTool::m_local
| private

full tool name "type/name"

Definition at line 822 of file GaudiTool.h.

INTupleSvc* GaudiTool::m_ntupleSvc = nullptr
| mutable private

pointer to the N-Tuple service

Definition at line 798 of file GaudiTool.h.

bool GaudiTool::s_enableSummary = true
| static private

enable printout of summary?

summary is enabled

Definition at line 827 of file GaudiTool.h.

The documentation for this class was generated from the following files:

- GaudiAlg/GaudiAlg/GaudiTool.h
- GaudiAlg/src/lib/GaudiTool.cpp